
/*+----------------------------------------------------------------------------------------+
  +ROCFX.mq4                                                                               +
  +ROCFX Indicator - Comprised of the conjuction of 2 ROC indicators: ROC short & ROC long +
  +                                                                                        +
  + Copyright  2013 September 29,                                                         +
  +----------------------------------------------------------------------------------------+ */


//---- ROCFX indicator settings
#property  copyright "Copyright  09-2013, I.G.M - M.PAP"
#property indicator_separate_window         // Indicator is drawn in the main window
#property indicator_buffers 6               // Number of buffers

#property indicator_color1 Blue            // Color of the 2nd line - short ROC 
#property indicator_color2 Red             // Color of the 3rd line - long ROC
#property indicator_color3 Green           // Color of Weighted Moving Average 10 of ROC Sums (Short + Long)
#property indicator_color4 Yellow          // Color of the 4th line - Triangular
#property indicator_color5 Orange          // Color of the 5th line - SMA25
#property indicator_color6 Maroon          // Color of the 6th line - SMA7

//---- ROCFX indicator parameters
extern int ROC_short_value = 12;
extern int ROC_long_value  = 19;
extern int Weighted_Moving_average_period = 10;
extern int MA_Triangular_average_period = 4;
extern int SMA_long_upon_FAST_ROCK = 25;
extern int SMA_short_upon_FAST_ROCK = 7;
extern bool Use_Percent = true;
extern int  BarsToCount         = 25000;

//---- ROCFX indicator buffer: SUM(ROC short,ROC long)
double ROC_final[];                               // Declaring arrays to hold the final ROC as the difference: (ROC_short - ROC_long)
double ROC_short[],ROC_long[];                    // Declaring arrays (in order to hold 2 RSI indicator buffers - short & long)    
double ROC_MA_Weighted[];                         // Weigted Moving Average for period of 10! 
double Triangular_ROC[];                          // Triangular Moving Average for period of 4 over ROC Weigthed Average above! 
double ROC_SMA_25[];                              // Array to hold the applicability of SMA-25 upon ROCFX (fast ROC)
double ROC_SMA_7[];                               // Array to hold the applicability of SMA-7 on SMA-25!

datetime lastBarTime;

 
//--------------------------------------------------------------------
int init()                                    
  {
   SetIndexBuffer(0,ROC_short);                 // Assignement of ROC-short to a buffer at 1ST position
   SetIndexStyle (0,DRAW_LINE,STYLE_DOT,2);     // Line style
   SetIndexLabel(0,"ROC short: " +ROC_short_value+ " ");
   
   SetIndexBuffer(1,ROC_long);                  // Assignement of ROC-long to a buffer at 2ND position
   SetIndexStyle (1,DRAW_LINE,STYLE_DOT,2);     // Line style 
   SetIndexLabel(1,"ROC long: " +ROC_long_value+ " ");
   
   SetIndexBuffer(2,ROC_MA_Weighted);           // Assignement of ROCFX to a buffer at 3RD position
   SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,2);   // Line style
   SetIndexLabel(2,"ROC Weighted: " +Weighted_Moving_average_period+ " ");
   
   SetIndexBuffer(3,Triangular_ROC);            // Assignement of Triangular MA to a buffer at 4TH position
   SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,2);   // Line style
   SetIndexLabel(3,"Triangular MA: " +MA_Triangular_average_period+ " ");
   
   SetIndexBuffer(4,ROC_SMA_25);   
   SetIndexStyle (4,DRAW_LINE,STYLE_SOLID,2);   // Line style
   SetIndexLabel(4,"ROC-SMA-25: " +SMA_long_upon_FAST_ROCK+ " ");
   
   SetIndexBuffer(5,ROC_SMA_7);
   SetIndexStyle (5,DRAW_LINE,STYLE_SOLID,2);   // Line style
   SetIndexLabel(5,"ROC-SMA-7: " +SMA_short_upon_FAST_ROCK+ " ");
   
   //IndicatorShortName("ROCFX Weighted MA of period(" + Weighted_Moving_average_period + ")& Triangular MA of period(" + MA_Triangular_average_period + ")";  //Name for DataWindow and indicator subwindow label
   
   //BarsToCount = MathMin(Bars,MathMax(BarsToCount,300));
   
  //if(ArraySize(ROC_MA_Weighted) != Bars) ArrayResize(ROC_MA_Weighted, Bars);
   ArrayResize(ROC_MA_Weighted,BarsToCount);
   ArraySetAsSeries(ROC_MA_Weighted,true);
   
   //if(ArraySize(ROC_final) != Bars) ArrayResize(ROC_final, Bars);
   ArrayResize(ROC_final,BarsToCount);
   ArraySetAsSeries(ROC_final,true);
   
  // if(ArraySize(ROC_short) != Bars) ArrayResize(ROC_short, Bars);
   ArrayResize(ROC_short,BarsToCount);
   ArraySetAsSeries(ROC_short,true);
   
  // if(ArraySize(ROC_long) != Bars) ArrayResize(ROC_long, Bars);
   ArrayResize(ROC_long,BarsToCount);
   ArraySetAsSeries(ROC_long,true);
   
   //if(ArraySize(Triangular_ROC) != Bars) ArrayResize(Triangular_ROC, Bars);
   ArrayResize(Triangular_ROC,BarsToCount);
   ArraySetAsSeries(Triangular_ROC,true);
   
   //  if(ArraySize(ROC_SMA_25) != BarsToCount) ArrayResize(ROC_SMA_25, BarsToCount);
   ArrayResize(ROC_SMA_25,BarsToCount);
   ArraySetAsSeries(ROC_SMA_25,true);
   
  //if(ArraySize(ROC_SMA_7) != Bars) ArrayResize(ROC_SMA_7, Bars);
   ArrayResize(ROC_SMA_7,BarsToCount);
   ArraySetAsSeries(ROC_SMA_7,true);
   return;                                    
  }
//--------------------------------------------------------------------

int start()
{
       
   int limit, i;
   double ROC, Current_Close, Short_Close, Long_Close, ROC_Short_diff, ROC_Long_diff;
   int counted_bars = IndicatorCounted();       // Number of counted bars
   
 //---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
 
 // SOS - New Code added!      
   if(lastBarTime != Time[0]) {
      lastBarTime  = Time[0];
                  counted_bars = 0;
      }     
          
   if(counted_bars>0) counted_bars--;
      limit=Bars-counted_bars-1;
    //  limit=MathMin(limit,BarsToCount);   
   //Print("Limit is: " +limit+ "Bars:" +Bars+ " counted_bars: " +counted_bars+ " ");  
   
// SOS - New Code added - end! 

 
//--------------------------------------------------------------------
     
 //  i=Bars-counted_bars-1;           // Index of the first uncounted
 //  while(i>=0)                      // Loop for uncounted bars
 
    for(i=limit;i>=0;i--) 
     {
      Current_Close = iClose(NULL, 0, i);
      Short_Close   = iClose(NULL, 0, i + ROC_short_value);
      Long_Close    = iClose(NULL, 0, i + ROC_long_value);
      
      ROC_Short_diff = Current_Close - Short_Close;
      ROC_Long_diff  = Current_Close - Long_Close;
   
   // 1)  ROC short calculation   
      if(Use_Percent)
         {
           if(Short_Close != 0)
               ROC_short[i] = 100 * ROC_Short_diff / Short_Close;
         }
      else
           ROC_short[i] = ROC_Short_diff;
           
      double ROC_s = ROC_short[i];
           
    //       Print("ROC_short[i] is: " +ROC_s+ "i: " +i+ " ");
      
    //-------------------- end of ROC short calculation  
      
    // 2)  ROC long calculation   
      if(Use_Percent)
         {
           if(Long_Close != 0)
               ROC_long[i] = 100 * ROC_Long_diff / Long_Close;
         }
      else
           ROC_long[i] = ROC_Long_diff;
        
      double ROC_l = ROC_long[i];    
      //  Print("ROC_long[i] is: " +ROC_l+ "i: " +i+ " ");
               
      //------------------ end of ROC long calculation  
      
      ROC_final[i] = ROC_s + ROC_l;
      double ROC_f = ROC_final[i];
      
     //  Print("ROC_final[i] is: " +ROC_f+ "i:" +i+ " ");
      
           
      ROC_MA_Weighted[i] = iMAOnArray(ROC_final,0,Weighted_Moving_average_period,0,MODE_LWMA,i);
      double ROC_MA_W = ROC_MA_Weighted[i];
           
     //    Print("ROC_MA_Weighted[i] is: " +ROC_MA_W+ "i:" +i+ " ");
     
    
        
      Triangular_ROC[i] = TriMA(ROC_MA_Weighted,MA_Triangular_average_period,i); 
   //      double   Triangular_ROC_V = Triangular_ROC[i];
    //    Print("1. Triangular_ROC_V is: " +Triangular_ROC_V+ " i: " +i+ " ");
        
     // double ROC_SMA_25_v = iMA(Symbol(),0,25,0,MODE_SMMA,PRICE_CLOSE,i)/Point;
   //     Print("2. ROC_SMA_25_v is: " +ROC_SMA_25_v+ " i: " +i+ " ");
        //ROC_SMA_25[i] = ROC_SMA_25_v;
    //  Print("ROC_SMA_25_v is: " +ROC_SMA_25_v+ " i: " +i+ " ");
       
      ROC_SMA_25[i] = iMAOnArray(ROC_MA_Weighted,0,SMA_long_upon_FAST_ROCK,0,MODE_SMMA,i) ;
 //    double ROC_SMA_25_v = ROC_SMA_25[i];
 //    Print("1.ROC_SMA_25_v is: " +ROC_SMA_25_v+ " i: " +i+ " ");
     //  double ROC_SMA_25_p = ROC_SMA_25[i]; 
     //  Print("ROC_SMA_25_p is: " +ROC_SMA_25_p+ " i: " +i+ " ");
      ROC_SMA_7[i]  = iMAOnArray(ROC_SMA_25,0,SMA_short_upon_FAST_ROCK,0,MODE_SMMA,i);
    //double ROC_SMA_7_v = ROC_SMA_7[i];
    //Print("2.ROC_SMA_7_v is: " +ROC_SMA_7_v+ " i: " +i+ " ");
      //  double ROC_SMA_7_p = ROC_SMA_7[i];
     //   Print("ROC_SMA_7_p is: " +ROC_SMA_7_p+ " i: " +i+ " ");
           
  //    i--;                                                    // Calculate index of the next bar, i.e. we are reaching the latest bar
     }
     
     
//--------------------------------------------------------------------
  
   return;                          
  }


//---------- Note: These 2 indexes below are taken from AllAverages_v3.1.mq4
// (1) MA_Method=0: SMA - Simple Moving Average
double SMA(double array[],int per,int bar)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) 
       Sum += array[bar+i];
   
   
   return(Sum/per);
}                

// (2) TriMA - Triangular Moving Average
double TriMA(double array[],int per,int bar)
{
   double sma;
   int len = MathCeil((per+1)*0.5);
   
   double sum=0;
   for(int i = 0;i < len;i++) 
   {
   sma = SMA(array,len,bar+i);
   sum += sma;
   } 
   double trima = sum/len;
   
   return(trima);
}



